#ifndef x_basics_h_included_lskdsoweitjkjsd
#define x_basics_h_included_lskdsoweitjkjsd


/***********************************************************************
 *                                                                     *
 *                               BASICS                                *
 *                                                                     *
 ***********************************************************************/

/****
    - opens the display
    - finds a 24-bit visual
    - gets various properties
      -- root window size
      -- pixel format
****/

extern Display *x_display;
extern Window   x_root_window;
extern int      x_screen_number;
extern uint32_t x_root_width, x_root_height;
extern uint32_t x_red_mask, x_red_shift,
                x_green_mask, x_green_shift,
                x_blue_mask, x_blue_shift;
extern int      x_depth;
extern Visual  *x_visual;

int init_display(char *name);

Window create_window
              (Window parent, int x,int y, int w, int h,
               unsigned int events, int border, int override);


/***********************************************************************
 *                                                                     *
 *                            EVENT SYSTEM                             *
 *                                                                     *
 ***********************************************************************/

void register_event_handler(Window window, unsigned int event,
                         void *data, void *func, void**old);
void unregister_event_handler(Window window, unsigned int event, void *old);
void unregister_all_event_handlers(Window window);
void handle_registered_event(XEvent *event);

void call_event_handler(void *H,XEvent *event);
void free_event_handler(void *H);

int grab_key(char *keyspec, int *Rmod, int *Rkey,
             void *press_func, void *release_func, void *arg);

int grab_keyboard(void *press_func, void *release_func, void *arg);
void ungrab_keyboard();

void grab_extra_modifiers(char *exmod);


/***********************************************************************
 *                                                                     *
 *                           IMAGE HANDLING                            *
 *                                                                     *
 ***********************************************************************/

typedef struct 
{
  uint32_t *data;
  unsigned int width,height, bpl;
  int shared;
  XShmSegmentInfo shminfo;
  XImage *x11image;
} ximage_t;


ximage_t *create_image(uint32_t width, uint32_t height);
void      destroy_image(ximage_t *image);
void      put_image(Window window, int dest_x, int dest_y,
                    ximage_t *image, int src_x, int src_y,
                    int width, int height);
void      handle_image_chores();

#endif
